#ifndef _OLD_MACROS_2_17_H
#define _OLD_MACROS_2_17_H      1

/*
 * Contains macros that have been defined in glibc2.34. 
 * Cancel the definition and use the old version.
 * This header file needs to be included at the end.
 */
#undef __lll_unlock
#define __lll_unlock(futex, private)                    \
  ((void)                                               \
   ({                                                   \
     int *__futex = (futex);                            \
     int __private = (private);                         \
     int __oldval = atomic_exchange_rel (__futex, 0);   \
     if (__glibc_unlikely (__oldval > 1))               \
       lll_futex_wake (__futex, 1, __private);          \
   }))

#undef lll_unlock
#define lll_unlock(futex, private)      \
  __lll_unlock (&(futex), private)

extern int __lll_timedlock_wait (int *futex, const struct timespec *,
                                 int private) attribute_hidden;


/* As __lll_lock, but with a timeout.  If the timeout occurs then return
   ETIMEDOUT.  If ABSTIME is invalid, return EINVAL.  */
#define __lll_timedlock(futex, abstime, private)                \
  ({                                                            \
    int *__futex = (futex);                                     \
    int __val = 0;                                              \
                                                                \
    if (__glibc_unlikely                                        \
        (atomic_compare_and_exchange_bool_acq (__futex, 1, 0))) \
      __val = __lll_timedlock_wait (__futex, abstime, private); \
    __val;                                                      \
  })
#define lll_timedlock(futex, abstime, private)  \
  __lll_timedlock (&(futex), abstime, private)

/* Verify whether the supplied clockid is supported by
   lll_futex_clock_wait_bitset.  */
#define lll_futex_supported_clockid(clockid)                    \
  ((clockid) == CLOCK_REALTIME || (clockid) == CLOCK_MONOTONIC)

/* The kernel currently only supports CLOCK_MONOTONIC or
   CLOCK_REALTIME timeouts for FUTEX_WAIT_BITSET.  We could attempt to
   convert others here but currently do not.  */
#define lll_futex_clock_wait_bitset(futexp, val, clockid, timeout, private) \
  ({                                                                    \
    long int __ret;                                                     \
    if (lll_futex_supported_clockid (clockid))                          \
      {                                                                 \
        const unsigned int clockbit =                                   \
          (clockid == CLOCK_REALTIME) ? FUTEX_CLOCK_REALTIME : 0;       \
        const int op =                                                  \
          __lll_private_flag (FUTEX_WAIT_BITSET | clockbit, private);   \
                                                                        \
        __ret = lll_futex_syscall (6, futexp, op, val,                  \
                                   timeout, NULL /* Unused.  */,        \
                                   FUTEX_BITSET_MATCH_ANY);             \
      }                                                                 \
    else                                                                \
      __ret = -EINVAL;                                                  \
    __ret;                                                              \
  })

# undef INTERNAL_VSYSCALL
# define INTERNAL_VSYSCALL INTERNAL_SYSCALL
# undef INLINE_VSYSCALL
# define INLINE_VSYSCALL INLINE_SYSCALL

#endif
